﻿using BenchmarkDotNet.Order;
using BenchmarkDotNet.Reports;
using BenchmarkDotNet.Running;
using System.Collections.Generic;
using System.Collections.Immutable;
using System.Linq;

namespace FlexGridBenchmark.Config
{
    public class SummaryOrderer : DefaultOrderer
    {
        public override IEnumerable<BenchmarkCase> GetSummaryOrder(ImmutableArray<BenchmarkCase> benchmarksCase, Summary summary) =>
            from benchmark in benchmarksCase
            orderby benchmark.Descriptor.Type.ToString(),
                benchmark.Descriptor.WorkloadMethod.Name,
                benchmark.Parameters["RowCount"],
                benchmark.Parameters["ColumnCount"],
                benchmark.Job.Environment.Runtime.Name descending
            select benchmark;
    }
}
